﻿$PBExportHeader$w_sale_send_his_fx.srw
$PBExportComments$查看销售发送的历史消息
forward
global type w_sale_send_his_fx from w_publ_base_style
end type
type cb_retrieve from uo_imflatbutton within w_sale_send_his_fx
end type
type st_1 from statictext within w_sale_send_his_fx
end type
type dp_timea from datepicker within w_sale_send_his_fx
end type
type st_2 from statictext within w_sale_send_his_fx
end type
type dp_timez from datepicker within w_sale_send_his_fx
end type
type cbx_1 from checkbox within w_sale_send_his_fx
end type
type dw_1 from u_dw_rbtnfilter within w_sale_send_his_fx
end type
end forward

global type w_sale_send_his_fx from w_publ_base_style
integer width = 3698
integer height = 2024
string title = "销售电子商务记录(发送)"
boolean maxbox = true
boolean resizable = true
long backcolor = 16777215
string icon = "graphics\chain_link_128px.ico"
cb_retrieve cb_retrieve
st_1 st_1
dp_timea dp_timea
st_2 st_2
dp_timez dp_timez
cbx_1 cbx_1
dw_1 dw_1
end type
global w_sale_send_his_fx w_sale_send_his_fx

forward prototypes
public function integer wf_retrieve ()
end prototypes

public function integer wf_retrieve ();int rslt = 1
string msg

dw_1.Reset()

datetime timeA, timeZ
timeA = datetime(date(dp_timea.Value), time('00:00:00'))
timeZ = datetime(date(dp_timez.Value), time('23:59:59'))

if (timeA > timeZ) then
	rslt = 0
	msg = '日期范围有误'
	goto ext
end if

string arg_msg
oleobject list, item
list = FXAppCom.GetSaleSendHis(app_token_fx, string(timeA), string(timeZ), ref arg_msg)

if (arg_msg <> '') then
	rslt = 0
	arg_msg = '获取供应商协同电子商务记录失败:' + arg_msg
	goto ext
end if

long i
dw_1.SetRedraw(false)
for i = 1 to list.Count
	item = list.GetItem(i - 1)
	
	dw_1.Object.comname[i] = item.GetString('comname')
	dw_1.Object.SerialNum[i] = item.GetString('serialNum')
	dw_1.Object.SendSCcode[i] = item.GetString('sendSCcode')
	dw_1.Object.AddUser[i] = item.GetString('addUser')
	dw_1.Object.AddTime[i] = item.GetDateTime('addTime')
	dw_1.Object.Status[i] = item.GetInt('status')
	dw_1.Object.BillType[i] = item.GetInt('billType')
	dw_1.Object.Summary[i] = item.GetString('summary')
	dw_1.Object.Postscript[i] = item.GetString('postscript')
	dw_1.Object.Remark[i] = item.GetString('remark')
	dw_1.Object.RelatedCode[i] = item.GetString('relatedCode')
	dw_1.Object.r_postscript[i] = item.GetString('rpostscript')
	dw_1.Object.r_remark[i] = item.GetString('rremark')
next
dw_1.SetRedraw(true)

ext:
if (rslt = 0) then
	MessageBox('提示', '错误:' + msg)
end if

return rslt
end function

on w_sale_send_his_fx.create
int iCurrent
call super::create
this.cb_retrieve=create cb_retrieve
this.st_1=create st_1
this.dp_timea=create dp_timea
this.st_2=create st_2
this.dp_timez=create dp_timez
this.cbx_1=create cbx_1
this.dw_1=create dw_1
iCurrent=UpperBound(this.Control)
this.Control[iCurrent+1]=this.cb_retrieve
this.Control[iCurrent+2]=this.st_1
this.Control[iCurrent+3]=this.dp_timea
this.Control[iCurrent+4]=this.st_2
this.Control[iCurrent+5]=this.dp_timez
this.Control[iCurrent+6]=this.cbx_1
this.Control[iCurrent+7]=this.dw_1
end on

on w_sale_send_his_fx.destroy
call super::destroy
destroy(this.cb_retrieve)
destroy(this.st_1)
destroy(this.dp_timea)
destroy(this.st_2)
destroy(this.dp_timez)
destroy(this.cbx_1)
destroy(this.dw_1)
end on

event open;call super::open;dp_timea.Value = DateTime(RelativeDate(Today(), - 7), Time('00:00:00'))
dp_timez.Value = DateTime(Today(), Time('23:59:59'))

wf_retrieve()
end event

event resize;call super::resize;if (this.Width < 3660) then this.Width = 3660
if (this.Height < 1900) then this.Height = 1900

dw_1.Width = this.workspacewidth( )
dw_1.Height = this.workspaceheight( ) - dw_1.Y

cb_exit.X = this.workspacewidth( ) - cb_exit.Width
end event

type cb_func from w_publ_base_style`cb_func within w_sale_send_his_fx
boolean visible = false
end type

type cb_exit from w_publ_base_style`cb_exit within w_sale_send_his_fx
integer x = 2491
end type

type ln_bar from w_publ_base_style`ln_bar within w_sale_send_his_fx
end type

type ln_bar2 from w_publ_base_style`ln_bar2 within w_sale_send_his_fx
end type

type r_bar from w_publ_base_style`r_bar within w_sale_send_his_fx
end type

type cb_retrieve from uo_imflatbutton within w_sale_send_his_fx
integer width = 151
integer height = 164
integer taborder = 20
boolean bringtotop = true
string text = "刷新"
string normalpicname = "refresh.bmp"
integer picsize = 16
toolbaralignment pic_align = alignattop!
boolean border = false
end type

event clicked;call super::clicked;wf_retrieve()
end event

type st_1 from statictext within w_sale_send_his_fx
integer x = 23
integer y = 200
integer width = 325
integer height = 48
boolean bringtotop = true
integer textsize = -9
integer weight = 400
fontcharset fontcharset = gb2312charset!
fontpitch fontpitch = variable!
string facename = "宋体"
long textcolor = 33554432
long backcolor = 16777215
string text = "发送日期从:"
boolean focusrectangle = false
end type

type dp_timea from datepicker within w_sale_send_his_fx
integer x = 329
integer y = 184
integer width = 462
integer height = 84
integer taborder = 20
boolean bringtotop = true
borderstyle borderstyle = stylelowered!
date maxdate = Date("2999-12-31")
date mindate = Date("1800-01-01")
datetime value = DateTime(Date("2016-11-04"), Time("10:31:24.000000"))
integer textsize = -9
fontcharset fontcharset = gb2312charset!
fontpitch fontpitch = variable!
string facename = "宋体"
integer calendarfontweight = 400
boolean todaysection = true
boolean todaycircle = true
boolean valueset = true
end type

type st_2 from statictext within w_sale_send_his_fx
integer x = 809
integer y = 200
integer width = 82
integer height = 48
boolean bringtotop = true
integer textsize = -9
integer weight = 400
fontcharset fontcharset = gb2312charset!
fontpitch fontpitch = variable!
string facename = "宋体"
long textcolor = 33554432
long backcolor = 16777215
string text = "到"
boolean focusrectangle = false
end type

type dp_timez from datepicker within w_sale_send_his_fx
integer x = 882
integer y = 184
integer width = 462
integer height = 84
integer taborder = 30
boolean bringtotop = true
borderstyle borderstyle = stylelowered!
date maxdate = Date("2999-12-31")
date mindate = Date("1800-01-01")
datetime value = DateTime(Date("2016-11-04"), Time("10:33:29.000000"))
integer textsize = -9
fontcharset fontcharset = gb2312charset!
fontpitch fontpitch = variable!
string facename = "宋体"
integer calendarfontweight = 400
boolean todaysection = true
boolean todaycircle = true
boolean valueset = true
end type

type cbx_1 from checkbox within w_sale_send_his_fx
integer x = 1381
integer y = 196
integer width = 411
integer height = 60
boolean bringtotop = true
integer textsize = -9
integer weight = 400
fontcharset fontcharset = gb2312charset!
fontpitch fontpitch = variable!
string facename = "宋体"
long textcolor = 33554432
long backcolor = 16777215
string text = "只显示待处理"
end type

event clicked;if (dw_1.RowCount() <= 0) then return

if (this.Checked) then
	dw_1.SetFilter('status=0 or status=1 or status=2 or status=3') // [0]待发送 [1]发送失败 [2]发送成功 [3]对方已打开
	dw_1.Filter()
else
	dw_1.SetFilter('')
	dw_1.Filter()
end if
end event

type dw_1 from u_dw_rbtnfilter within w_sale_send_his_fx
integer y = 276
integer width = 3662
integer height = 1520
integer taborder = 20
boolean bringtotop = true
string dataobject = "dw_fx_send_his"
boolean hscrollbar = true
boolean vscrollbar = true
boolean rbutton_filter_use = true
boolean rbutton_setposition_use = true
boolean titleclick_sort_use = true
end type

event clicked;call super::clicked;if (row > 0) then
	this.SelectRow(0, false)
	this.SelectRow(row, true)
	this.SetRow(row)
end if
end event

