﻿$PBExportHeader$w_spt_ch_fx.srw
$PBExportComments$(采购)选择供应商界面
forward
global type w_spt_ch_fx from w_publ_choice
end type
end forward

global type w_spt_ch_fx from w_publ_choice
integer width = 3310
string title = "选择供应商"
boolean controlmenu = true
long backcolor = 16777215
string icon = "graphics\chain_link_128px.ico"
boolean center = true
end type
global w_spt_ch_fx w_spt_ch_fx

type variables
s_fx_company ins_ret
end variables

forward prototypes
public function integer wf_retrieve ()
end prototypes

public function integer wf_retrieve ();//
int rslt = 1

dw_ch.Reset()

string arg_msg
oleobject list, item
list = FXAppCom.GetMySptList(app_token_fx, ref arg_msg)

if (arg_msg <> '') then
	rslt = 0
	goto ext
end if

dw_ch.SetRedraw(false)
long i
for i = 1 to list.Count
	item = list.GetItem(i - 1)
	
	dw_ch.Object.comid[i] = item.GetInt('comid')
	dw_ch.Object.comname[i] = item.GetString('comname')
	dw_ch.Object.simplename[i] = item.GetString('simplename')
	dw_ch.Object.custype[i] = item.GetString('custype')
	dw_ch.Object.tele[i] = item.GetString('tele')
	dw_ch.Object.address[i] = item.GetString('address')
	dw_ch.Object.freight[i] = item.GetString('freight')
	dw_ch.Object.freight_tele[i] = item.GetString('freight_tele')
next
dw_ch.SelectRow(0, false)
dw_ch.SetRedraw(true)

ext:
return rslt
end function

on w_spt_ch_fx.create
call super::create
end on

on w_spt_ch_fx.destroy
call super::destroy
end on

event open;ins_ret.ifselect = false

wf_retrieve()
end event

event close;call super::close;CloseWithReturn(this, ins_ret)
end event

type cb_func from w_publ_choice`cb_func within w_spt_ch_fx
end type

type cb_exit from w_publ_choice`cb_exit within w_spt_ch_fx
end type

type sle_ch from w_publ_choice`sle_ch within w_spt_ch_fx
end type

type dw_ch from w_publ_choice`dw_ch within w_spt_ch_fx
integer width = 3301
integer height = 1440
string dataobject = "dw_fx_spt_ch"
boolean rbutton_filter_use = true
boolean rbutton_setposition_use = true
boolean titleclick_sort_use = true
end type

event dw_ch::clicked;call super::clicked;this.SelectRow(0, false)

if (row > 0) then
	this.SelectRow(row, true)
end if
end event

type st_1 from w_publ_choice`st_1 within w_spt_ch_fx
long backcolor = 16777215
end type

type cb_retrieve from w_publ_choice`cb_retrieve within w_spt_ch_fx
end type

event cb_retrieve::clicked;wf_retrieve()
end event

type cb_choice from w_publ_choice`cb_choice within w_spt_ch_fx
end type

event cb_choice::clicked;call super::clicked;long row
row = dw_ch.GetRow()
if (row <= 0) then
	MessageBox('提示', '请在下面的清单内选中一个供应商')
	return
end if

if not dw_ch.IsSelected(row) then
	MessageBox('提示', '请在下面的清单内选中一个供应商')
	return
end if

ins_ret.comid[1] = dw_ch.Object.comid[row]
ins_ret.comname[1] = Trim(dw_ch.Object.comname[row])
ins_ret.ifselect = true

Close(parent)
end event

type ln_bar from w_publ_choice`ln_bar within w_spt_ch_fx
end type

type ln_bar2 from w_publ_choice`ln_bar2 within w_spt_ch_fx
end type

type r_bar from w_publ_choice`r_bar within w_spt_ch_fx
end type

type ln_1 from w_publ_choice`ln_1 within w_spt_ch_fx
end type

type ln_2 from w_publ_choice`ln_2 within w_spt_ch_fx
end type

