﻿$PBExportHeader$w_fx_binding_apply.srw
$PBExportComments$协同-绑定申请列表
forward
global type w_fx_binding_apply from w_publ_base_style
end type
type dw_1 from u_dw_rbtnfilter within w_fx_binding_apply
end type
type cb_1 from commandbutton within w_fx_binding_apply
end type
type cb_2 from commandbutton within w_fx_binding_apply
end type
end forward

global type w_fx_binding_apply from w_publ_base_style
integer y = 388
integer width = 3376
integer height = 1594
string title = "绑定申请"
boolean minbox = false
windowtype windowtype = response!
long backcolor = 16777215
string icon = "graphics\chain_link_128px.ico"
boolean center = true
dw_1 dw_1
cb_1 cb_1
cb_2 cb_2
end type
global w_fx_binding_apply w_fx_binding_apply

type variables
int ins_rslt = 0 // 0 - 无操作返回  1 - 操作成功返回
end variables

forward prototypes
public subroutine wf_reply_binding_apply (integer arg_flag)
public subroutine wf_retrieve ()
end prototypes

public subroutine wf_reply_binding_apply (integer arg_flag);// arg_flag 0-待处理；1-同意；2-拒绝
Long row
row = dw_1.GetRow()
IF row <= 0 THEN
	MessageBox('','未选中需要处理的记录')
	RETURN
END IF
String arg_msg
OpenWithParm(w_packet_msg_edit_fx, arg_msg)

s_open_packet s_ret
s_ret = Message.PowerObjectParm
if (s_ret.returnflag = 0) then
	MessageBox('提示', '操作取消')
	return
end if


String dscrp
dscrp = s_ret.postscript
if IsNull(dscrp) then
	dscrp = ''
end if

Long bindingId
bindingId = dw_1.Object.id[row]

arg_msg = ''
oleobject request,response

request  = FXAppCom.CreatePbDictionary()
request.SetString('token',app_token_fx)
request.SetInt("bindingId",bindingId)
request.SetInt('flag',arg_flag)
request.SetString('dscrp',dscrp)
response = FXAppCom.DoExecute("ReplyBindingApply",request)
arg_msg = response.GetString('ErrMsg')
if (arg_msg <> '') then
	MessageBox('',arg_msg)
ELSE
	MessageBox('','操作成功')
	wf_retrieve()
end if
end subroutine

public subroutine wf_retrieve ();dw_1.Reset()
String arg_msg
oleobject request,response,bindingApplyList
Long cnt
cnt = 0

request  = FXAppCom.CreatePbDictionary()
request.SetString('token',app_token_fx)
response = FXAppCom.DoExecute("GetBindingApplyList",request)
arg_msg = response.GetString('ErrMsg')
if (arg_msg <> '') then
	MessageBox('',arg_msg)
	RETURN
end if
bindingApplyList = response.GetPBArray("bindingApplyList")
IF IsValid(bindingApplyList) THEN
	cnt = bindingApplyList.Count
END IF
IF cnt <= 0 THEN
	RETURN
END IF
Long row, i
oleobject item
FOR i = 1 TO cnt
	item = bindingApplyList.GetPBDictionary(i - 1)
	row = dw_1.InsertRow(0)
	dw_1.Object.id[row] = item.GetInt("id")
	dw_1.Object.fx_binding_apply_applydscrp[row] = item.GetString("applydscrp")
	dw_1.Object.fx_binding_apply_opdate[row] = item.GetDateTime("opdate")
	dw_1.Object.fx_binding_apply_opemp[row] = item.GetString("opemp")
	dw_1.Object.fx_company_comname[row] = item.GetString("comname")
	dw_1.Object.fx_company_simplename[row] = item.GetString("simplename")
	dw_1.Object.fx_company_custype[row] = item.GetString("custype")
	dw_1.Object.fx_company_tele[row] = item.GetString("tele")
NEXT
end subroutine

on w_fx_binding_apply.create
int iCurrent
call super::create
this.dw_1=create dw_1
this.cb_1=create cb_1
this.cb_2=create cb_2
iCurrent=UpperBound(this.Control)
this.Control[iCurrent+1]=this.dw_1
this.Control[iCurrent+2]=this.cb_1
this.Control[iCurrent+3]=this.cb_2
end on

on w_fx_binding_apply.destroy
call super::destroy
destroy(this.dw_1)
destroy(this.cb_1)
destroy(this.cb_2)
end on

event open;call super::open;wf_retrieve()
end event

event close;call super::close;CloseWithReturn(this, ins_rslt)
end event

event resize;call super::resize;dw_1.Width = this.workspacewidth( )
dw_1.Height = this.workspaceheight( ) - dw_1.Y - 263

cb_1.Y = dw_1.Y + dw_1.Height + 63
cb_2.Y = dw_1.Y + dw_1.Height + 63
cb_exit.Y = dw_1.Y + dw_1.Height + 63
end event

type cb_func from w_publ_base_style`cb_func within w_fx_binding_apply
boolean visible = false
integer x = 1558
integer y = 1421
integer width = 274
string text = "确认发货"
string normalpicname = "ok.bmp"
integer picsize = 16
end type

type cb_exit from w_publ_base_style`cb_exit within w_fx_binding_apply
integer x = 2973
integer y = 1334
integer width = 300
integer height = 99
string normalpicname = ""
integer picsize = 0
end type

type ln_bar from w_publ_base_style`ln_bar within w_fx_binding_apply
integer beginy = 0
integer endy = 0
end type

type ln_bar2 from w_publ_base_style`ln_bar2 within w_fx_binding_apply
integer beginy = 3
integer endy = 3
end type

type r_bar from w_publ_base_style`r_bar within w_fx_binding_apply
end type

type dw_1 from u_dw_rbtnfilter within w_fx_binding_apply
integer width = 3350
integer height = 1267
integer taborder = 20
boolean bringtotop = true
boolean titlebar = true
string title = "申请企业"
string dataobject = "dw_fx_binding_apply"
boolean hscrollbar = true
boolean vscrollbar = true
boolean hsplitscroll = true
boolean rbutton_filter_use = true
boolean rbutton_setposition_use = true
boolean titleclick_sort_use = true
end type

event clicked;call super::clicked;if (row <= 0) then return

this.SelectRow(0, false)
this.SelectRow(row, true)
end event

event itemfocuschanged;call super::itemfocuschanged;if (row > 0) then
	this.SelectRow(0, false)
	this.SelectRow(row, true)
	this.SetRow(row)
	
	string colName
	colName = this.GetColumnName()
	if (colName = 'outqty' or colName = 'outwarecode') then
		this.SelectText(1, Len(this.GetText()))
	end if
end if
end event

type cb_1 from commandbutton within w_fx_binding_apply
integer x = 1869
integer y = 1334
integer width = 300
integer height = 99
integer taborder = 20
boolean bringtotop = true
integer textsize = -9
integer weight = 400
fontcharset fontcharset = gb2312charset!
fontpitch fontpitch = variable!
string facename = "宋体"
string text = "拒绝"
end type

event clicked;wf_reply_binding_apply(2)
end event

type cb_2 from commandbutton within w_fx_binding_apply
integer x = 1189
integer y = 1334
integer width = 300
integer height = 99
integer taborder = 20
boolean bringtotop = true
integer textsize = -9
integer weight = 400
fontcharset fontcharset = gb2312charset!
fontpitch fontpitch = variable!
string facename = "宋体"
string text = "同意"
end type

event clicked;wf_reply_binding_apply(1)
end event

