﻿$PBExportHeader$w_fx_checkitem_bymtrl.srw
forward
global type w_fx_checkitem_bymtrl from w_publ_easyq
end type
end forward

global type w_fx_checkitem_bymtrl from w_publ_easyq
integer width = 3031
integer height = 2032
string title = "物料质检项目"
windowstate windowstate = normal!
end type
global w_fx_checkitem_bymtrl w_fx_checkitem_bymtrl

type variables
long ins_fxmtrlid,ins_cuscomid
end variables

forward prototypes
public subroutine wf_refresh ()
end prototypes

public subroutine wf_refresh ();string arg_msg
oleobject request,response,fx_mtrl,item

request = FXAppCom.CreatePbDictionary()
request.SetString('token', app_token_fx)
request.SetInt('fxmtrlid', ins_fxmtrlid)
request.SetInt('cuscomid', ins_cuscomid)

response = FXAppCom.DoExecute('GetFxCheckItemByMtrl', request)
arg_msg = response.GetString('ErrMsg')

if (arg_msg <> '') then
    messagebox('提示', '获取物料质检项目失败，原因：' + arg_msg)
    return
end if
fx_mtrl = response.GetArrOfPBDictionary('FxCheckItem')

IF  isnull(fx_mtrl) THEN
    RETURN
END IF

IF  fx_mtrl.Count <= 0 THEN
    RETURN
END IF

dw_1.Reset()
dw_1.SetRedraw(false)
long i,row
for i = 1 to fx_mtrl.Count
	 item = fx_mtrl.GetItem(i - 1)
    
	 row = dw_1.InsertRow(0)

	 dw_1.Object.comid[row] = item.GetInt('comid')
	 dw_1.Object.itemid_erp[row] = item.GetInt('itemid_erp')
	 dw_1.Object.itemcode[row] = item.GetString('itemcode')
	 dw_1.Object.itemname[row] = item.GetString('itemname')
	 dw_1.Object.standard[row] = item.GetString('standard')
	 dw_1.Object.environmen[row] = item.GetString('environmen')
	 dw_1.Object.method[row] = item.GetString('method')
	 dw_1.Object.basis[row] = item.GetString('basis')
	 dw_1.Object.equipment[row] = item.GetString('equipment')
	 dw_1.Object.handtype[row] = item.GetString('handtype')
	 dw_1.Object.dscrp[row] = item.GetString('dscrp')
	 dw_1.Object.isuse[row] = item.GetInt('isuse')
	 
next

dw_1.SetRedraw(true)
end subroutine

on w_fx_checkitem_bymtrl.create
call super::create
end on

on w_fx_checkitem_bymtrl.destroy
call super::destroy
end on

event open;call super::open;s_edit_index_tran s_tran 
s_tran = Message.PowerObjectParm

IF NOT IsNull(s_tran.d_string ) THEN
	THIS.Title = s_tran.d_string
END IF

ins_fxmtrlid = s_tran.d_long
ins_cuscomid = s_tran.e_long
wf_refresh()
end event

type cb_func from w_publ_easyq`cb_func within w_fx_checkitem_bymtrl
boolean visible = false
end type

type cb_exit from w_publ_easyq`cb_exit within w_fx_checkitem_bymtrl
integer x = 274
integer width = 270
end type

type cb_2 from w_publ_easyq`cb_2 within w_fx_checkitem_bymtrl
boolean visible = false
end type

type cb_psetup from w_publ_easyq`cb_psetup within w_fx_checkitem_bymtrl
boolean visible = false
end type

type cb_1 from w_publ_easyq`cb_1 within w_fx_checkitem_bymtrl
integer width = 270
end type

event cb_1::clicked;call super::clicked;wf_refresh()
end event

type st_3 from w_publ_easyq`st_3 within w_fx_checkitem_bymtrl
boolean visible = false
end type

type st_4 from w_publ_easyq`st_4 within w_fx_checkitem_bymtrl
boolean visible = false
end type

type em_1 from w_publ_easyq`em_1 within w_fx_checkitem_bymtrl
boolean visible = false
end type

type em_2 from w_publ_easyq`em_2 within w_fx_checkitem_bymtrl
boolean visible = false
end type

type ddlb_yl from w_publ_easyq`ddlb_yl within w_fx_checkitem_bymtrl
boolean visible = false
end type

type cbx_yl from w_publ_easyq`cbx_yl within w_fx_checkitem_bymtrl
boolean visible = false
end type

type dw_1 from w_publ_easyq`dw_1 within w_fx_checkitem_bymtrl
integer y = 180
integer width = 2976
integer height = 1732
string dataobject = "dw_fx_checkitem_bymtrl"
end type

type sle_mtrl from w_publ_easyq`sle_mtrl within w_fx_checkitem_bymtrl
end type

type sle_cust from w_publ_easyq`sle_cust within w_fx_checkitem_bymtrl
end type

type st_mtrl from w_publ_easyq`st_mtrl within w_fx_checkitem_bymtrl
end type

type st_cust from w_publ_easyq`st_cust within w_fx_checkitem_bymtrl
end type

type cbx_loginretr from w_publ_easyq`cbx_loginretr within w_fx_checkitem_bymtrl
end type

type pb_em1 from w_publ_easyq`pb_em1 within w_fx_checkitem_bymtrl
boolean visible = false
end type

type pb_em2 from w_publ_easyq`pb_em2 within w_fx_checkitem_bymtrl
boolean visible = false
end type

type pb_2 from w_publ_easyq`pb_2 within w_fx_checkitem_bymtrl
boolean visible = false
end type

type cb_help from w_publ_easyq`cb_help within w_fx_checkitem_bymtrl
boolean visible = false
end type

type cb_copyself from w_publ_easyq`cb_copyself within w_fx_checkitem_bymtrl
boolean visible = false
end type

type gb_1 from w_publ_easyq`gb_1 within w_fx_checkitem_bymtrl
end type

type ln_bar from w_publ_easyq`ln_bar within w_fx_checkitem_bymtrl
end type

type ln_bar2 from w_publ_easyq`ln_bar2 within w_fx_checkitem_bymtrl
end type

type r_bar from w_publ_easyq`r_bar within w_fx_checkitem_bymtrl
end type

type ln_1 from w_publ_easyq`ln_1 within w_fx_checkitem_bymtrl
boolean visible = false
end type

type ln_2 from w_publ_easyq`ln_2 within w_fx_checkitem_bymtrl
boolean visible = false
end type

type ln_3 from w_publ_easyq`ln_3 within w_fx_checkitem_bymtrl
integer beginy = 176
integer endy = 176
end type

type ln_4 from w_publ_easyq`ln_4 within w_fx_checkitem_bymtrl
end type

